<template>
    <div class="reset pa-16">
        <v-row
            :class="[
                { 'pl-5 pr-5': $vuetify.breakpoint.smAndDown },
                { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
                'pt-16',
            ]"
        >
            <v-col md="4" offset-md="4">
                <v-row>
                    <v-col class="pt-0 text-left">
                        <v-row>
                            <v-col class="pt-0">
                                <h2>
                                    {{ $t('auth.resetPassword') }}
                                </h2>
                                <h3>
                                    {{ $t('auth.enterPassword') }}
                                </h3>
                            </v-col></v-row
                        >
                        <v-form
                            v-show="pageLoaded"
                            ref="resetPasswordForm"
                            lazy-validation
                            @submit.prevent
                        >
                            <v-row>
                                <v-col>
                                    <v-col
                                        cols="12"
                                        class="form-field font-metropolis-regular pl-0"
                                    >
                                        <!-- PASSWORD -->
                                        <v-text-field
                                            ref="password"
                                            v-model="form.password.value"
                                            :append-icon="
                                                showPass
                                                    ? 'mdi-eye'
                                                    : 'mdi-eye-off'
                                            "
                                            :rules="[
                                                requiredRules,
                                                requiredMin,
                                            ]"
                                            :type="
                                                showPass ? 'text' : 'password'
                                            "
                                            name="input-10-2"
                                            :label="$t('auth.newPassword')"
                                            :placeholder="
                                                $t('auth.newPassword')
                                            "
                                            :hint="$t('form.password.min')"
                                            class="input-group--focused"
                                            solo
                                            @click:append="showPass = !showPass"
                                        ></v-text-field>

                                        <!-- CONFIRM PASSWORD -->
                                        <v-text-field
                                            ref="password"
                                            v-model="form.confirmPassword.value"
                                            :append-icon="
                                                showPass2
                                                    ? 'mdi-eye'
                                                    : 'mdi-eye-off'
                                            "
                                            :rules="[
                                                requiredRules,
                                                requiredMin,
                                                requiredMatch,
                                            ]"
                                            :type="
                                                showPass2 ? 'text' : 'password'
                                            "
                                            name="input-10-2"
                                            :label="$t('auth.confirmPassword')"
                                            :placeholder="
                                                $t('auth.confirmPassword')
                                            "
                                            :hint="$t('form.password.min')"
                                            class="input-group--focused"
                                            solo
                                            @click:append="
                                                showPass2 = !showPass2
                                            "
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" class="pa-0">
                                        <v-btn
                                            :block="
                                                $vuetify.breakpoint.smAndDown
                                            "
                                            :loading="loading"
                                            :disabled="loading"
                                            class="mt-5 lowercase br-0 pl-10 pr-10 font-syne-bold"
                                            color="badge"
                                            @click="validateForm"
                                            >{{
                                                $t('auth.resetPassword')
                                            }}</v-btn
                                        >
                                    </v-col>
                                </v-col>
                            </v-row>
                        </v-form>
                    </v-col>
                </v-row>
            </v-col>
        </v-row>
    </div>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
const { VueMaskDirective } = require('v-mask')

Vue.directive('mask', VueMaskDirective)

@Component<any>({
    middleware: ['authenticated'],
    head() {
        return {
            title: this.$t('auth.resetPassword'),
        }
    },
})
export default class ResetPassword extends Vue {
    // Data
    $refs!: { resetPasswordForm: HTMLFormElement }
    ref: any = this.$refs
    pageLoaded: boolean = false
    loading: Boolean = false
    showPass: Boolean = false
    showPass2: Boolean = false
    formHasErrors: Boolean = false
    form: { [key: string]: any } = {
        password: {
            value: '',
            error: null,
            requestKey: 'password',
        },
        confirmPassword: {
            value: '',
            error: null,
            requestKey: 'confirmPassword',
        },
    }

    isButtonDisabled = false

    // Rules
    requiredRules(v: string) {
        if (v) {
            return true
        } else {
            return this.$t('form.validation.required')
        }
    }

    requiredMin(v: string) {
        if (v) {
            if (v.length >= 8) {
                return true
            }
        }
        return this.$t('form.password.min')
    }

    requiredMatch(v: string) {
        if (v) {
            if (this.form.password.value === v) {
                return true
            }
        }
        return this.$t('form.password.match')
    }

    validateForm() {
        if (typeof this.$refs === 'undefined') {
            return
        }

        setTimeout(() => {
            const valid = this.$refs.resetPasswordForm.validate()

            if (valid) {
                this.submit()
            }
        }, 300)
    }

    submit() {
        // token, email, password, password_confirmation
        this.isButtonDisabled = true
        this.loading = true
        this.$api.auth
            .resetPassword(
                this.$route.params.slug,
                this.$route.query.email,
                this.form.password.value,
                this.form.confirmPassword.value
            )
            .then(() => {
                // Display snackbar
                const val = {
                    text: this.$t('snackbar.passwordResetSuccessful'),
                    color: 'green',
                    icon: 'mdi-check',
                }
                this.$store.dispatch('snackbar/displaySnackBar', val)

                // Redirect
                this.$router.push('/login')
                this.loading = false
            })
            .catch((error) => {
                if (error.response.status === 401) {
                    this.loading = false
                }

                // Get errors object
                const errors = error.response.data.errors

                // Get keys of error
                const errorKeys: string[] = Object.keys(errors)

                // Set error messages
                for (const errorKey of errorKeys) {
                    // Display snackbar
                    const val = {
                        text: errors[errorKey][0],
                        color: 'red',
                        icon: ' mdi-close-circle',
                    }
                    this.$store.dispatch('snackbar/displaySnackBar', val)
                }

                // Reopen button
                this.isButtonDisabled = false
                this.loading = false
            })
    }

    mounted() {
        if (typeof this.$refs !== 'undefined') {
            this.ref = this.$refs
            this.pageLoaded = true
        }
    }
}
</script>
